﻿using System.Collections.Generic;
using System.ServiceModel;
using VisualComponents.UX.Shared;

namespace VC.WcfServiceDemo
{
    /// <summary>
    /// IVCService describes the operations that a client can invoke. It specifies a callback contract, IVCServiceCallback,
    /// in the ServiceContractAttribute.CallbackContract property. IVCServiceCallback is the interface that defines 
    /// the operations that the service can call on the client endpoint.
    /// </summary>
    
    [ServiceContract (Namespace = "http://VisualComponents.ServiceModel.Demo",
                     CallbackContract=typeof(IVCServiceCallback), SessionMode =SessionMode.Required)]
    public interface IVCService : IPlugin
    {      
        [OperationContract(IsInitiating = true)]
        bool Subscribe();

        [OperationContract(IsInitiating = false)]
        bool UnSubscribe();

        [OperationContract (IsOneWay =true)]
        void LoadLayout(string LayoutUri);

        [OperationContract(IsOneWay = true)]
        void SelectComponent(string Name);
    }
}
